%% Hessiana

dSigma = 1e-5;
grad = dPsis*wv';
HH_matr = Hessian_num(s,dSigma);
HH_vec = HH_matr*(wv)'; % combinazione lineare delle Hessiane con i pesi
HH_matr = [HH_vec(1) , HH_vec(4), HH_vec(6); HH_vec(4), HH_vec(2), HH_vec(5); HH_vec(6),  HH_vec(5), HH_vec(3)]; % riordino elementi Hessiana
w_hess = wv_der*dPsis';
HH = HH_matr + w_hess;


function HH_matr = Hessian_num(s,dSigma)

    [~,Phis,~] = Phi_array(s);
    [~,Phis_sx_plus,~] = Phi_array(s + [dSigma;0;0]);
    [~,Phis_sy_plus,~] = Phi_array(s + [0;dSigma;0]);
    [~,Phis_txy_plus,~] = Phi_array(s + [0;0;dSigma]);
    [~,Phis_sx_minus,~] = Phi_array(s - [dSigma;0;0]);
    [~,Phis_sy_minus,~] = Phi_array(s - [0;dSigma;0]);
    [~,Phis_txy_minus,~] = Phi_array(s - [0;0;dSigma;]);

    [~,Phis_sx_sy_plus,~] = Phi_array(s + [dSigma;dSigma;0]);
    [~,Phis_sy_txy_plus,~] = Phi_array(s + [0;dSigma;dSigma]);
    [~,Phis_sx_txy_plus,~] = Phi_array(s + [dSigma;0;dSigma]);
    [~,Phis_sx_sy_minus,~] = Phi_array(s - [dSigma;dSigma;0]);
    [~,Phis_sy_txy_minus,~] = Phi_array(s - [0;dSigma;dSigma]);
    [~,Phis_sx_txy_minus,~] = Phi_array(s - [dSigma;0;dSigma;]);

    [~,Phis_sx_p_sy_m,~] = Phi_array(s + [dSigma;-dSigma;0]);
    [~,Phis_sy_p_txy_m,~] = Phi_array(s + [0;dSigma;-dSigma]);
    [~,Phis_sx_p_txy_m,~] = Phi_array(s + [dSigma;0;-dSigma]);
    [~,Phis_sx_m_sy_p,~] = Phi_array(s + [-dSigma;dSigma;0]);
    [~,Phis_sy_m_txy_p,~] = Phi_array(s + [0;-dSigma;dSigma]);
    [~,Phis_sx_m_txy_p,~] = Phi_array(s + [-dSigma;0;dSigma;]);


    HH_matr(1,:) = (Phis_sx_plus + 2*Phis - Phis_sx_minus)/dSigma^2; % H11
    
    HH_matr(2,:) = (Phis_sy_plus + 2*Phis - Phis_sy_minus)/dSigma^2; % H22
    
    HH_matr(3,:) = (Phis_txy_plus + 2*Phis - Phis_txy_minus)/dSigma^2; % H33
    
    HH_matr(4,:) = (Phis_sx_sy_plus + Phis_sx_sy_minus - ...
        Phis_sx_p_sy_m - Phis_sx_m_sy_p)/(4*dSigma^2); % H12
    
    HH_matr(5,:) = (Phis_sy_txy_plus + Phis_sy_txy_minus - ...
        Phis_sy_p_txy_m - Phis_sy_m_txy_p)/(4*dSigma^2); % H23
    
    HH_matr(6,:) = (Phis_sx_txy_plus + Phis_sx_txy_minus - ...
        Phis_sx_p_txy_m - Phis_sx_m_txy_p)/(4*dSigma^2);

end